%define i18ndate 20010626

Name:		bash
Version:	4.0
%define subrel 1
Release:	%mkrel 7
Summary:	The GNU Bourne Again shell (bash)
Group:		Shells
License:	GPLv2+
URL:		http://www.gnu.org/software/bash/bash.html
Source0:	ftp://ftp.gnu.org/pub/gnu/bash/%{name}-%{version}.tar.gz
Source1:	%{SOURCE0}.sig
Source2:	ftp://ftp.gnu.org/pub/gnu/bash/bash-doc-3.2.tar.bz2
Source3:	dot-bashrc
Source4:	dot-bash_profile
Source5:	dot-bash_logout
Source6:	alias.sh
Source7:	bashrc
Patch1:		bash-2.02-security.patch
# ensure profile is read (Redhat)
Patch3:		bash-4.0-profile.patch
Patch4:		bash-2.05b-readlinefixes.patch
Patch6:		bash-2.04-compat.patch
#https://bugzilla.novell.com/attachment.cgi?id=67684
Patch100:	bash-3.1-extended_quote.patch
# Official upstream patches
Patch201:   bash40-001.patch
Patch202:   bash40-002.patch
Patch203:   bash40-003.patch
Patch204:   bash40-004.patch
Patch205:   bash40-005.patch
Patch206:   bash40-006.patch
Patch207:   bash40-007.patch
Patch208:   bash40-008.patch
Patch209:   bash40-009.patch
Patch210:   bash40-010.patch
Patch211:   bash40-011.patch
Patch212:   bash40-012.patch
Patch213:   bash40-013.patch
Patch214:   bash40-014.patch
Patch215:   bash40-015.patch
Patch216:   bash40-016.patch
Patch217:   bash40-017.patch
Patch218:   bash40-018.patch
Patch219:   bash40-019.patch
Patch220:   bash40-020.patch
Patch221:   bash40-021.patch
Patch222:   bash40-022.patch
Patch223:   bash40-023.patch
Patch224:   bash40-024.patch
Patch225:   bash40-025.patch
Patch226:   bash40-026.patch
Patch227:   bash40-027.patch
Patch228:   bash40-028.patch
Patch229:   bash40-029.patch
Patch230:   bash40-030.patch
Patch231:   bash40-031.patch
Patch232:   bash40-032.patch
Patch233:   bash40-033.patch
# none
Patch1000:	bash-strcoll-bug.diff
Patch1003:	bash-2.05b-checkwinsize.patch
Patch1004:	bash-3.2-lzma-copmpletion.patch
# (fc) 3.2-12mdv speedup bash completion (Fedora) (Fedora bug #475229)
Patch1005:	bash-3.2-speed-completion.patch
# (fc) 3.2-12mdv fix format string
Patch1006:	bash-3.2-format-security.patch
Patch1007:	bash-cve-2008-5374.patch
BuildRequires:	autoconf2.5
BuildRequires:	bison
BuildRequires:	groff
BuildRequires:	libtermcap-devel
BuildRequires:	texinfo
Conflicts:	etcskel <= 1.63-11mdk
Conflicts:	fileutils < 4.1-5mdk
Conflicts:	setup < 2.7.4-1mdv
Obsoletes:	bash3 < 3.2.48
Provides:	bash3
# explicit file provides
Provides:	/bin/sh
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Bash is a GNU project sh-compatible shell or command language
interpreter. Bash (Bourne Again shell) incorporates useful features
from the Korn shell (ksh) and the C shell (csh). Most sh scripts
can be run by bash without modification.

Bash offers several improvements over sh, including command line
editing, unlimited size command history, job control, shell
functions and aliases, indexed arrays of unlimited size and 
integer arithmetic in any base from two to 64. Bash is ultimately
intended to conform to the IEEE POSIX P1003.2/ISO 9945.2 Shell and
Tools standard.

%package doc
Summary:	Documentation for the GNU Bourne Again shell (bash)
Group:		Books/Computer books
Requires:	%{name} = %{version}-%{release}
Obsoletes:	bash3-doc < 3.2.48
Provides:	bash3-doc

%description doc
This package provides documentation for GNU Bourne Again shell (bash).

%prep
%setup -q -a 2
mv doc/README .

%patch1 -p1 -b .security
%patch3 -p1 -b .profile
# 20060126 warly obsolete exept maybe for the replacement of @ by kH, this will have to be checked
#%patch4 -p1 -b .readline
%patch6 -p1 -b .compat
%patch1000 -p1 -b .strcoll_bugx
%patch1003 -p1 -b .checkwinsize
%patch1004 -p1 -b .lzma
%patch1006 -p1 -b .format-security
%patch100 -p0 -b .quote

%patch201 -p0
%patch202 -p0
%patch203 -p0
%patch204 -p0
%patch205 -p0
%patch206 -p0
%patch207 -p0
%patch208 -p0
%patch209 -p0
%patch210 -p0
%patch211 -p0
%patch212 -p0
%patch213 -p0
%patch214 -p0
%patch215 -p0
%patch216 -p0
%patch217 -p0
%patch218 -p0
%patch219 -p0
%patch220 -p0
%patch221 -p0
%patch222 -p0
%patch223 -p0
%patch224 -p0
%patch225 -p0
%patch226 -p0
%patch227 -p0
%patch228 -p0
%patch229 -p0
%patch230 -p0
%patch231 -p0
%patch232 -p0
%patch233 -p0

# security
%patch1007 -p1

echo %{version} > _distribution
echo %{release} > _patchlevel
sed -i -e s/mdk// _patchlevel

%build
#libtoolize --copy --force

#export CFLAGS="$RPM_OPT_FLAGS"
#export CONFIGURE_TOP=".."
export DEBUGGER_START_FILE="%{_datadir}/bashdb/bashdb-main.inc"

%configure2_5x \
    --disable-command-timing \
    --disable-rpath \
    --enable-history \
    --enable-job-control \
    --enable-multibyte \
    --enable-readline \
    --with-installed-readline \
    --with-gnu-malloc \
    --without-bash-malloc

%make
#CFLAGS="$RPM_OPT_FLAGS"
# all tests must pass
%check
make check

%install
rm -rf %{buildroot}

%makeinstall_std

# beurk
rm -rf %{buildroot}%{_datadir}/locale/en@boldquot/ %{buildroot}%{_datadir}/locale/en@quot/

#Sucks
chmod +w doc/texinfo.tex
chmod 755 examples/misc/aliasconv.*
chmod 755 examples/misc/cshtobash
chmod 755 %{buildroot}%{_bindir}/bashbug

# Take out irritating ^H's from the documentation
mkdir tmp_doc
for i in `/bin/ls doc/` ; \
	do cat doc/$i > tmp_doc/$i ; \
	cat tmp_doc/$i | perl -p -e 's/.//g' > doc/$i ; \
	rm tmp_doc/$i ; \
	done
rmdir tmp_doc

mkdir -p %{buildroot}/bin
pushd %{buildroot} && mv usr/bin/bash bin/bash && popd
pushd %{buildroot}/bin && ln -s bash sh && popd
pushd %{buildroot}/bin && ln -sf bash bash3 && popd

# make builtins.1 and rbash.1 with bash.1 in place (fix mdv#51379)
pushd doc
mkdir tmp_fix_so
cd tmp_fix_so
cp ../builtins.1 ../rbash.1 .
sed -e '/^.if \\n(zZ=1 .ig zZ/,/^.zZ/d' ../bash.1 > bash.1
soelim builtins.1 > ../builtins.1
sed -e '/^.if \\n(zY=1 .ig zY/,/^.zY/d' ../bash.1 > bash.1
soelim rbash.1    > ../rbash.1
popd

# make manpages for bash builtins as per suggestion in DOC/README
cd doc
sed -e '
/^\.SH NAME/, /\\- bash built-in commands, see \\fBbash\\fR(1)$/{
/^\.SH NAME/d
s/^bash, //
s/\\- bash built-in commands, see \\fBbash\\fR(1)$//
s/,//g
b
}
d
' builtins.1 > man.pages
install -m 644 builtins.1 %{buildroot}%{_mandir}/man1/builtins.1

install -m 644 rbash.1 %{buildroot}%{_mandir}/man1/rbash.1

for i in `cat man.pages` ; do
  echo .so man1/builtins.1 > %{buildroot}%{_mandir}/man1/$i.1
done

# now turn man.pages into a filelist for the man subpackage

cat man.pages |tr -s ' ' '\n' |sed '
1i\
%defattr(0644,root,root,0755)
s:^:%{_mandir}/man1/:
s/$/.1%{_extension}/
' > ../man.pages

perl -p -i -e 's!.*/(printf|export|echo|pwd|test|kill).1%{_extension}!!' ../man.pages

mkdir -p %{buildroot}%{_sysconfdir}/skel
mkdir -p %{buildroot}%{_sysconfdir}/profile.d
install -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/skel/.bashrc
install -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/skel/.bash_profile
install -m 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/skel/.bash_logout
install -m 755 %{SOURCE6} %{buildroot}%{_sysconfdir}/profile.d/alias.sh
install -m 644 %{SOURCE7} %{buildroot}%{_sysconfdir}/bashrc

ln -s bash %{buildroot}/bin/rbash

# These're provided by other packages
rm -f %{buildroot}{%{_infodir}/dir,%{_mandir}/man1/{echo,export,kill,printf,pwd,test}.1}

cd ..

install -m 644 doc/bash.info %{buildroot}%{_infodir}/

%find_lang %{name}

# merges list
cat man.pages %{name}.lang > files.list

%clean
rm -rf %{buildroot}

%files -f files.list
%defattr(-,root,root)
%doc README 
%config(noreplace) %{_sysconfdir}/skel/.b*
%{_sysconfdir}/profile.d/alias.sh
%config(noreplace) %{_sysconfdir}/bashrc
/bin/rbash
/bin/bash
/bin/bash3
/bin/sh
%{_infodir}/bash.info*
%{_mandir}/man1/bash.1*
%{_mandir}/man1/rbash.1*
%{_mandir}/man1/builtins.1*
%{_mandir}/man1/bashbug.1*
%{_bindir}/bashbug
%exclude %{_datadir}/locale/ru/LC_MESSAGES/bash.mo

%files doc
%defattr(-,root,root)
%doc COMPAT NEWS NOTES POSIX CHANGES
%doc examples
%doc doc/*.ps doc/*.0 doc/*.html doc/article.txt


%changelog
* Wed Jan 13 2010 Eugeni Dodonov <eugeni@mandriva.com> 4.0-7.1mdv2010.0
- Updated alias script to prevent displaying control chars by default (CVE-2010-0002).
- Security fix for CVE-2008-5374.

* Tue Oct 06 2009 Thierry Vignaud <tvignaud@mandriva.com> 4.0-7mdv2010.0
+ Revision: 454756
- package CHANGE in doc

* Fri Sep 18 2009 Eugeni Dodonov <eugeni@mandriva.com> 4.0-6mdv2010.0
+ Revision: 444369
- Updated to patchset 33.

* Sun Aug 30 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 4.0-5mdv2010.0
+ Revision: 422505
- synch patches with upstream (225,226,227 and 228)
- tune up configure options

* Tue Jul 28 2009 Frederic Crozat <fcrozat@mandriva.com> 4.0-4mdv2010.0
+ Revision: 402384
- Update default configuration to use same prompt for xterm and screen titles (Fedora)
- Add warning in default configuration hinting users to create a separate file in /etc/profile.d (Fedora)

* Thu Jun 18 2009 Wanderlei Cavassin <cavassin@mandriva.com.br> 4.0-3mdv2010.0
+ Revision: 387176
- make builtins.1 and rbash.1 with in place bash.1 pertinent lines,
  avoiding problem in sourcing a compressed man (fix mdv #51379)

* Tue Jun 02 2009 Eugeni Dodonov <eugeni@mandriva.com> 4.0-2mdv2010.0
+ Revision: 382268
- Updated to official patchset 24.

* Fri May 01 2009 Guillaume Rousse <guillomovitch@mandriva.org> 4.0-1mdv2010.0
+ Revision: 370148
- new version
- drop documentation, not available for this version anymore

* Wed Feb 25 2009 Guillaume Rousse <guillomovitch@mandriva.org> 3.2.48-3mdv2009.1
+ Revision: 344740
- rebuild against new readline

* Mon Feb 09 2009 Guillaume Rousse <guillomovitch@mandriva.org> 3.2.48-2mdv2009.1
+ Revision: 339012
- drop fedora catch-all completion patch, as it break completion definition output format, causing troubles in indirect completions such as sudo

  + Tomasz Pawel Gajc <tpg@mandriva.org>
    - bunzip all patches

* Mon Jan 12 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 3.2.48-1mdv2009.1
+ Revision: 328797
- update to new version 3.2.48
- patches from 101 to 148 were merged upstream
- new license policy
- fix mixture of tabs and spaces
- better description for doc subpackage
- disable rpath
- enable few configure options
- versionate obsoletes
- spec file clean

* Wed Dec 17 2008 Frederic Crozat <fcrozat@mandriva.com> 3.2-12mdv2009.1
+ Revision: 315133
- Remove dietlibc build, useless
- Remove patches 13 (no longer needed), 90 (replaced by configuration in setup package)
- Regenerate patch 3, 135
- Patch1005 (Behdad): speedup bach completion (Fedora bug #475229)
- Patch1006: fix format string

* Fri Dec 05 2008 Guillaume Rousse <guillomovitch@mandriva.org> 3.2-11mdv2009.1
+ Revision: 310749
- update to official patch level 48
- re-enable official patches 20 to 25, #35880 seems to be fixed

* Fri Dec 05 2008 Pixel <pixel@mandriva.com> 3.2-10mdv2009.1
+ Revision: 310732
- .bash_profile: calling keychain is already done in /etc/profile.d/99keychain.sh (fixes #46045)

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - remove rather usless info in description

* Wed Aug 06 2008 Thierry Vignaud <tvignaud@mandriva.com> 3.2-9mdv2009.0
+ Revision: 264327
- rebuild early 2009.0 package (before pixel changes)

* Wed Jun 11 2008 Thierry Vignaud <tvignaud@mandriva.com> 3.2-8mdv2009.0
+ Revision: 218046
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Wed Dec 05 2007 Guillaume Rousse <guillomovitch@mandriva.org> 3.2-7mdv2008.1
+ Revision: 115767
- skip patches 21 to 25 to, as they don't apply cleanly when removing patch 20
- don't apply official patch 020, it seems to be responsible for bug #35880

* Thu Nov 29 2007 Guillaume Rousse <guillomovitch@mandriva.org> 3.2-6mdv2008.1
+ Revision: 113958
- update to current official patchset
- test profile scriptlet readability, not executability

* Fri Aug 31 2007 Pixel <pixel@mandriva.com> 3.2-5mdv2008.0
+ Revision: 76690
- cleanup temp variable (#31851)

* Sat Aug 11 2007 Olivier Blin <oblin@mandriva.com> 3.2-4mdv2008.0
+ Revision: 61891
- fix man page extension (using _extension macro)
- really add patches 16 and 17 (not twice again patch 15)

  + Thierry Vignaud <tvignaud@mandriva.com>
    - use color by default for egrep & grep

  + Anssi Hannula <anssi@mandriva.org>
    - add note about upgrading into alias.sh

  + Jérôme Soyer <saispo@mandriva.org>
    - Bump release
    - Add two patches

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - add lzma support to bash completion (P1004)

* Mon Apr 30 2007 Pixel <pixel@mandriva.com> 3.2-2mdv2008.0
+ Revision: 19543
- explicit file provide /bin/sh

* Thu Apr 19 2007 Jérôme Soyer <saispo@mandriva.org> 3.2-1mdv2008.0
+ Revision: 14985
- Apply Upstream patch


* Sat Apr 07 2007 Jérôme Soyer <saispo@mandriva.org> 3.2-1mdv2007.1
+ Revision: 151056
- New release

* Mon Jan 08 2007 Warly <warly@mandriva.com> 3.1-9mdv2007.1
+ Revision: 105951
- now /etc/bashrc is in bash
- now bashrc is in bash and not in setup any more (#10967)

* Sat Oct 14 2006 Nicholas Brown <nickbrown@mandriva.org> 3.1-8mdv2007.1
+ Revision: 64481
- fix debugger location
- Import bash

* Fri Aug 25 2006 Guillaume Rousse <guillomovitch@mandriva.org> 3.1-7mdv2007.0
- initialize keychain if needed in default .bash_profile (fix #12750)

* Thu Aug 24 2006 Gaetan Lehmann <glehmann@mandriva.org> 3.1-6mdv2007.0
- colored grep alias

* Wed Aug 23 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 3.1-5
- rebuild to fix changelog

* Tue May 23 2006 Warly <warly@mandriva.com> 3.1-3mdv2007.1- add extra bash patches up to patch017
* Thu May 11 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 3.1-3mdk
- make aliash.sh Bourne-complient (from Claudio, fixes #16188)

* Mon Feb 13 2006 Warly <warly@mandriva.com> 3.1-2mdk
- add patch 3.1-006 and 3.1-007
- add extended quote fix from novell (thanks Arnaud)

* Mon Jan 16 2006 Guillaume Rousse <guillomovitch@mandriva.org> 3.1-1mdk
- new version
- drop unused patches
- drop old patches 50 to 65, merged upstream
- add new 3.1 branch patches (64-68)

* Tue Jun 14 2005 Guillaume Rousse <guillomovitch@mandriva.org> 3.0-6mdk 
- don't source bash-completion from .bashrc, it is useless now
- shellbang in /etc/profile.d/alias.sh
- /etc/profile.d/alias.sh is not a config file
- spec cleanup

* Sat May 28 2005 Pixel <pixel@mandriva.com> 3.0-5mdk
- don't use CLASS from /etc/sysconfig/system which is deprecated

* Sat Apr 23 2005 G?tz Waschk <waschk@mandriva.org> 3.0-4mdk
- fix doc file generation
- fix rpm changelog

* Sat Apr 23 2005 G?tz Waschk <waschk@mandriva.org> 3.0-3mdk
- use the new name
- make spec short-circuit^{TM} compiant
- fix buildrequires
- don't set LESSOPEN in alias.sh, it's now in less.sh

* Fri Jan 07 2005 Warly <warly@mandrakesoft.com> 3.0-2mdk
- reinclude builtins man pages
- bash-doc obsoletes bash3-doc

* Thu Jan 06 2005 Warly <warly@mandrakesoft.com> 3.0-1mdk
- new version

* Fri Dec 31 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.05b-25mdk
- run testsuite, all tests shall pass
- really check for WCONTINUED support in waitpid() calls

* Thu Dec 30 2004 Stefan van der Eijk <stefan@mandrake.org> 2.05b-24mdk
- BuildRequires byacc --> bison
- fix Summary (rpmlint)

* Sat Nov 20 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.05b-23mdk
- fix the diet stuff

* Fri Aug 27 2004 Robert Vojta <robert.vojta@mandrake.org> 2.05b-22mdk
- do not waste resources with DIR_COLORS if ~/.dir_colors exists (#10945)

* Thu Aug 26 2004 Robert Vojta <robert.vojta@mandrake.org> 2.05b-21mdk
- look at the user defined colors too - ~/.dir_colors too (#10945)

* Fri Aug 20 2004 J?r?mie Lenfant-Engelmann <jlenfant@mandrakesoft.com> 2.05b-20mdk
- Patch1003: fix a bug with checkwinsize

* Fri Jul 23 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.05b-19mdk
- Patch12: fix builds with --enable-minimal-config
- Patch13: make it possible to build with dietlibc

* Sat Jul 10 2004 Guillaume Rousse <guillomovitch@mandrake.org> 2.05b-18mdk 
- fix use of the M.. word in description for doc package too
- fix perms
- no distinct URL for doc

* Fri Jul 09 2004 Guillaume Rousse <guillomovitch@mandrake.org> 2.05b-17mdk 
- enable bash-completion support from user .bashrc
- fix build with new gcc
- fix use of the M.. word in description
- spec cleanup
- removed unapplied patches

